
'---------------------------------------------------------------------------------------------------------
' Image List 
'--------------------------------------------------------------------------------------------------------- 

Type FImageList Extends Object 
	
	Public:		    
   Declare Property Handle As HIMAGELIST
   Declare Property Width() As Integer							' Get  Width
   Declare Property Width( ByVal value As Integer )		' Set  Width
  	Declare Property Height() As Integer						' Get  Height
   Declare Property Height( ByVal value As Integer )		' Set  Height
   Declare Property Count  As Integer							' Get  Count
   
   Declare Constructor				
   Declare Destructor
   Declare Sub Create(ByVal IMGcount As Integer,ByVal x As Integer,ByVal y As Integer )					
	Declare Sub DrawImg(ByVal dc As HDC,ByVal index As Integer, ByVal zielX As Integer, ByVal zielY As Integer)
	Declare Sub AddBMP(sName As String)
	Declare Sub AddIcon(sName As String)
	Declare Sub DelItem( ByVal index As Integer)
   Declare sub Clear
	Private: 
  
	As HIMAGELIST	b_Handle	= 0
	As Integer	b_Width 		= 0
   As Integer	b_Height  	= 0
   As Integer  b_Count		= 0
	
End Type
Constructor	FImageList
	this.b_Width 		= 32
	this.b_Height  	= 32
	this.b_Count		= 1
	this.b_Handle		= 0
End Constructor
Destructor FImageList
	ImageList_Destroy(this.b_Handle)
	This.b_Handle = 0
End Destructor
Sub FImageList.Create(ByVal IMGcount As Integer,ByVal x As Integer,ByVal y As Integer )					

	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf

	this.b_Width 		= x
	this.b_Height  	= y
	this.b_Count		= IMGcount
	
	This.b_Handle = ImageList_Create(b_Width, b_Height, ILC_COLOR	, b_Count, 1)
	
End Sub

Property FImageList.Handle As HIMAGELIST
	Return this.b_Handle
End Property
Property FImageList.Width() As Integer	
	Return this.b_Width
End Property
Property FImageList.Width( ByVal value As Integer )	
	this.b_Width = value
	ImageList_SetIconSize(this.b_Handle,this.b_Width,this.b_Height)
	' alle Images in der Liste werden gelscht !
End Property
Property FImageList.Height() As Integer					
	Return this.b_Height
End Property
Property FImageList.Height( ByVal value As Integer )		
	this.b_Height = value
	ImageList_SetIconSize(this.b_Handle,this.b_Width,this.b_Height)
	' alle Images in der Liste werden gelscht !
End Property
Property FImageList.Count  As Integer	
	this.b_Count = ImageList_GetImageCount(this.b_Handle)
	Return this.b_Count
End Property
Sub FImageList.AddBMP(sName As String)
	
	Dim As HINSTANCE hInst
   Dim As ZString * 128 szRes 
 	Dim As HBITMAP hBmp
 	
   hInst 	= GetModuleHandle(0)
   szRes		= sName
   
	If InStr(szRes,".") = 0 Then  	' Wenn kein Punkt (.) enthalen ist, dann Resource 
		hBmp	= LoadBitmap(hInst , cast( LPCSTR, @szRes ))	
		If hBmp  = 0 Then
			MessageBox( null, "Fehler - fBitmap ist nicht geladen", "Error", MB_ICONERROR )
			Exit sub
		EndIf
   Else										' mit Punkt (.) dann Deteiname
   	hBmp		= LoadImage(NULL,@szRes,IMAGE_Bitmap,0,0,LR_DEFAULTCOLOR Or LR_LOADFROMFILE )
		If hBmp  = 0 Then
			MessageBox( null, "Fehler - fBitmap ist nicht geladen", "Error", MB_ICONERROR )
			Exit sub
		EndIf  	
   End If
	
	if ImageList_Add(this.b_Handle,hBmp,NULL) = -1 Then
		MessageBox(0,"Bitmap wurde nicht in die ImageList kopiert","Fehler",MB_ICONERROR)
	EndIf
	If hBmp Then
		DeleteObject(hBmp)
	End If 
End Sub
Sub FImageList.AddIcon(sName As String)
	Dim As HINSTANCE hInst
   Dim As ZString * 128 szRes 
 	Dim As HICON hIco
 	
   hInst 	= GetModuleHandle(0)
   szRes		= sName
   
	If InStr(szRes,".") = 0 Then  	' Wenn kein Punkt (.) enthalen ist, dann Resource 
		hIco	= LoadIcon(hInst , cast( LPCSTR, @szRes ))	
		If hIco  = 0 Then
			MessageBox( null, "Fehler - Icon ist nicht geladen", "Error", MB_ICONERROR )
			Exit sub
		EndIf
   Else										' mit Punkt (.) dann Deteiname
   	hIco	= LoadImage(NULL,@szRes,IMAGE_ICON,0,0,LR_DEFAULTCOLOR Or LR_LOADFROMFILE )
		If hIco = 0 Then
			MessageBox( null, "Fehler - Icon ist nicht geladen", "Error", MB_ICONERROR )
			Exit sub
		EndIf  	
   End If
	
	if ImageList_AddIcon(this.b_Handle, hIco) = -1 Then
		MessageBox(0,"Icon wurde nicht in die ImageList kopiert","Fehler",MB_ICONERROR)
	EndIf
	If hIco Then
		DeleteObject(hIco)
	End If 
End Sub
Sub FImageList.DelItem( ByVal index As Integer)
	ImageList_Remove(this.b_handle, index)
End Sub
Sub FImageList.Clear
	ImageList_Remove(this.b_handle, -1)
End Sub
Sub FImageList.DrawImg(ByVal dc As HDC,ByVal index As Integer, ByVal zielX As Integer, ByVal zielY As Integer)
	if ImageList_Draw(this.b_Handle,index,dc,zielX,zielY,ILD_NORMAL) = 0 Then
		MessageBox(0," Fehler bei DRAWIMG - Parameter prfen","Fehler",MB_ICONERROR)
	EndIf	
End Sub

'---------------------------------------------------------------------------------------------------------
' Tab-Control
'--------------------------------------------------------------------------------------------------------- 
#Define NoImage -1 

Type FTabControl Extends Control	
  	Public:
  	Declare Property UnSelTextColor() As UInteger						
   Declare Property UnSelTextColor( ByVal value As UInteger )
   Declare Property SelTabColor() As UInteger						
   Declare Property SelTabColor( ByVal value As UInteger )
   Declare Property UnSelTabColor() As UInteger						
   Declare Property UnSelTabColor( ByVal value As UInteger )
  	Declare Property TabHeight() As Integer						
   Declare Property TabHeight( ByVal value As Integer )
   Declare Property TabCount() As Integer						
   Declare Property TabCount( ByVal value As Integer )
   Declare Property CurTab As Integer 
   Declare Property CurTab( ByVal value As Integer )
   Declare Sub addTab(TabCaption As String,ByVal ImgIndex As Integer )
	Declare Sub SetImageList(ByVal hImgList As HIMAGELIST )
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor
   ' Events	
   onChange As SUB( ByVal tbPos As Integer)	
   
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
	Private:
	
	Declare Sub DrawItem(lpDraw As LPDRAWITEMSTRUCT )
	DECLARE static FUNCTION SubClassFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
	As UInteger b_BgColor = &HF8E8d8
	As UInteger b_UnBgColor = &HFFFFFF
   As Integer  b_TabIndex	= -1
	As ZString * 128 b_szTab
	As Integer  b_TabHight  = 26
	As UInteger b_UnSelTextColor = &H0
	As UInteger b_oldProc	= 0
End Type

Constructor FTabControl
	
	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf
	
	this.b_TabIndex = -1
	this.b_UnSelTextColor = &H0
	this.Handle = 0
	this.Style 	= WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR TCS_FOCUSONBUTTONDOWN  OR TCS_RIGHTJUSTIFY OR TCS_OWNERDRAWFIXED 'TCS_MULTILINE 
	this.ExStyle = WS_EX_LEFT OR WS_EX_LTRREADING  
	            
End Constructor

Destructor FTabControl
	If this.Handle Then
		SetWindowLong(this.Handle, GWL_WNDPROC, this.b_oldProc)
	End If
   this.Handle  = 0
End Destructor

Property FTabControl.UnSelTextColor() As UInteger	
	Return this.b_UnSelTextColor
End Property
Property FTabControl.UnSelTextColor( ByVal value As UInteger )
	this.b_UnSelTextColor = value
End Property
Property FTabControl.TabHeight() As Integer		
	Return this.b_TabHight
End Property
Property FTabControl.TabHeight( ByVal value As Integer )
	Dim As Integer cx,cy
	Dim As RECT rc
	 
	this.b_TabHight = value
	If this.Handle Then
		TabCtrl_GetItemRect(this.Handle,0,@rc)
		cx = rc.right
		cy = value
		TabCtrl_SetItemSize(this.Handle,cx,cy)
	EndIf
End Property

Property FTabControl.SelTabColor() As UInteger	
	Return this.b_BgColor
End Property
Property FTabControl.SelTabColor( ByVal value As UInteger )
	this.b_BgColor = value
End Property
Property FTabControl.UnSelTabColor() As UInteger	
	Return this.b_UnBgColor
End Property
Property FTabControl.UnSelTabColor( ByVal value As UInteger )
	this.b_UnBgColor = value
End Property
   
Property FTabControl.TabCount() As Integer 
	If this.Handle Then
		Return TabCtrl_GetItemCount(this.Handle)
	EndIf
End Property
Property FTabControl.TabCount( ByVal value As Integer ) 
 '
End Property
Property FTabControl.CurTab As Integer 
	If this.Handle Then
		Return TabCtrl_GetCurSel(this.Handle)
	EndIf
End Property
Property FTabControl.CurTab( ByVal value As Integer )
	Dim As Integer i
	If this.Handle Then
		i = TabCtrl_GetItemCount(this.Handle)
		If (value >=0) And (value < i) Then
			If value <> TabCtrl_GetCurSel(This.Handle) Then
				If this.onChange Then this.onChange(value)
			EndIf
			TabCtrl_SetCurSel(this.Handle,value)
		EndIf	
	EndIf
End Property
Sub FTabControl.DrawItem(lpdis As LPDRAWITEMSTRUCT ) 
	
	Dim As BOOL bSel
	Dim hBr As HBRUSH
	Dim As TC_ITEM ti
	Dim As RECT rc
	Dim As HIMAGELIST hImg
	Dim As IMAGEINFO imgInfo 
	Dim As Integer x,y
	
	if (lpdis->itemID < 0) Or (lpdis->itemID > this.TabCount - 1) Then 
		Exit Sub
	EndIf
	
	If lpdis->itemID = TabCtrl_GetCurSel(this.Handle) Then
		bSel = TRUE
	Else
		bSel = FALSE
	EndIf
	
	CopyRect(@rc,@lpdis->rcItem)
	
	' Hintergrund 
	If bSel Then
		hBr = CreateSolidBrush(this.b_BgColor)
	Else
		hBr = CreateSolidBrush(this.b_UnBgColor)
	EndIf		
		FillRect(lpdis->hDC,@rc,hBr)
		DeleteObject(hBr)
		
		' TextFarbe	
		SetBkMode(lpdis->hDC,TRANSPARENT)
	If bSel Then	
		SetTextColor(lpdis->hDC,this.TextColor)
	Else	
		SetTextColor(lpdis->hDC,this.b_UnSelTextColor)
	EndIf
	
		' Text schreiben
		ti.mask = TCIF_TEXT Or TCIF_IMAGE
		ti.pszText = @b_szTab
		ti.cchTextMax = SIZEOF(b_szTab)
		TabCtrl_GetItem(lpdis->hwndItem, lpdis->itemID, @ti)
	
	hImg = Cast(HANDLE, SendMessage(this.Handle, TCM_GETIMAGELIST ,0,0)) 	
	If (hImg <> 0) And (ti.iImage <> -1) Then 		
		ImageList_GetImageInfo(hImg, lpdis->itemID , @imgInfo)
		TabCtrl_GetItemRect(this.Handle,lpdis->itemID,@rc)

		y = Int((rc.bottom - imgInfo.rcImage.bottom) / 2)
		x = rc.Left + 4
		
		ImageList_Draw(hImg, ti.iImage , lpdis->hDC, x ,y ,ILD_NORMAL)	
			
		CopyRect(@rc,@lpdis->rcItem)
		rc.left = rc.left + (imgInfo.rcImage.right-imgInfo.rcImage.left)			
		DrawText( lpdis->hDC, @b_szTab , -1, @rc , DT_SINGLELINE or DT_CENTER or DT_VCENTER )		
	Else
   	DrawText( lpdis->hDC, @b_szTab , -1, @lpdis->rcItem , DT_SINGLELINE or DT_CENTER or DT_VCENTER )	
	EndIf
		
End Sub
Sub FTabControl.addTab(TabCaption As String,ByVal ImgIndex As Integer )
	
	Dim As TC_ITEM ti
	Dim As RECT rc
	
	b_szTab = TabCaption
	
	ti.mask = TCIF_TEXT Or TCIF_IMAGE
	ti.iImage = ImgIndex
   ti.pszText =@b_szTab
   b_TabIndex = b_TabIndex + 1

   If this.handle Then 
   	If TabCtrl_InsertItem(this.handle, b_TabIndex, @ti ) = -1 Then 
            DestroyWindow(this.handle) 
            Exit sub
   	End If 
   	If TabCtrl_GetItemRect(this.handle, b_TabIndex,@rc) Then
	  		this.b_TabHight  = rc.bottom + 3
   	EndIf
		
   End If	
End Sub
Sub FTabControl.SetImageList(ByVal hImgList As HIMAGELIST )	
	TabCtrl_SetImageList(this.Handle,hImgList)	
End Sub
FUNCTION FTabControl.SubClassFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
	
	
	
	Dim as FTabControl ptr FTab = cast(FTabControl Ptr,GetWindowLong(hWnd,GWL_USERDATA)) ' Zeiger auf diese Klasse
	
	If FTab = 0 Then
		function = DefWindowProc(  hWnd, uMsg, wParam, lParam) 
		Exit Function
	EndIf
	
	Dim As HBRUSH hBr
	Dim As RECT rc
	
	Select case uMsg 
		
		Case WM_ERASEBKGND
			hBr = CreateSolidBrush(FTab->Color)
			GetClientRect(hWnd,@rc)
			FillRect(Cast(HDC, wParam),@rc,hBr)
			DeleteObject(hBr)
			Function = 1
			Exit Function
	End Select
	
	function = CallWindowProc( Cast(Any Ptr,FTab->b_oldProc), hWnd, uMsg, wParam, lParam) 
	
End Function

Function FTabControl.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT 
	
 	Dim As Integer iNr
 	
  	Select Case uMsg
  		CASE WM_ENABLE
         this.Enabled = wParam
         EXIT FUNCTION

  		Case WM_SETFONT,WM_SETTEXT,WM_SETFOCUS,WM_KILLFOCUS
         IF this.Handle THEN
             FUNCTION = SendMessage(this.Handle,uMsg,wParam,lParam)
         END IF
         EXIT FUNCTION

      CASE WM_SIZE
         IF this.Handle THEN
             MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
         END IF
         EXIT FUNCTION 
         
  		CASE WM_PAINT
         dim pnt as PAINTSTRUCT
         Dim As RECT rc
         Dim As HBRUSH hBr
         Dim As HDC hDC
         hDC = BeginPaint( hWnd, @pnt )
         	GetClientRect(hWnd,@rc)
		   	hBr = CreateSolidBrush(this.Color)
		   	FillRect(hDC,@rc,hBr)
		   	DeleteObject(hBr) 
		   EndPaint( hWnd, @pnt )
   		Function = 0		   
         EXIT FUNCTION  
                          
  		Case WM_DRAWITEM
			Dim As LPDRAWITEMSTRUCT lpdis = Cast(Any Ptr, lParam)
			DrawItem(lpdis )
   		Function = TRUE
   		Exit Function
   		'-------------------------    				  		
  		Case WM_NOTIFY	
			Dim pNMSC AS NMHDR Ptr = Cast(Any Ptr, lParam)  	 		
  			Select Case pNMSC->code 
  				Case TCN_SELCHANGE
  					iNr = TabCtrl_GetCurSel(pNMSC->hwndFrom)
  					If this.onChange Then this.onChange(iNr)
  			End select		
  			Function = 0
   		Exit Function
   		
  	End Select
   
    Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
End Function

Sub FTabControl.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )

    Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
         
   this.CtHandle = CreateWindowEx(NULL  , @szClass , "", WS_VISIBLE Or WS_CHILD  , x, y, w , h , _                    
                          hParent , NULL, hInst , NULL )
                                                   
                                                                    
   If this.CtHandle  Then  
   	SetWindowLong(this.CtHandle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz                        
   	
   	this.Left	 = x
		this.Top		 = y
   	this.Width 	 = w
  		this.Height  = h
   	this.Parent  = hParent  	
   Else
   	MessageBox(0,"Fehler - TabControl Container","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
                          
   this.Handle = CreateWindowEx( NULL , WC_TABCONTROL , "", this.Style  ,  0, 0, w, h , this.CtHandle , NULL, hInst , NULL )                                            
   If this.Handle = 0 Then
   	MessageBox(0,"Fehler - Create TabControl ","Fehler",MB_ICONERROR)
   	Exit Sub
   EndIf 
   
	this.b_oldProc = SetWindowLong( this.Handle, GWL_WNDPROC, CInt(@FTabControl.SubClassFunc))
	SetWindowLong(this.Handle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz
	
   TabCtrl_SetPadding(this.Handle,5,5)

End Sub
'-------------------------------------------------------------------------------------------
' UPDOWN
'-------------------------------------------------------------------------------------------
Type FUpDown Extends Control	
	public: 	
	Declare Property Upper(ByVal value As Short)
	Declare Property Upper As Short
	Declare Property Lower(ByVal value As Short)
	Declare Property Lower As Short
	Declare Property Curpos(ByVal value As Short)
	Declare Property Curpos As Short
	Declare Property Buddy(ByVal value As HWND)
	Declare Property Buddy As HWND
	Declare sub Range(ByVal min As  USHORT ,ByVal max As  USHORT )	    
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor  
   ' Events
   onChange As Sub(ByVal nPos As Integer)	
   ' Func
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT  
   Private:
   As HWND b_hBuddy 	= 0
   As Short b_UP 	= 10
   As Short b_LO	= 0
   As Short b_POS	= 0

End Type
Constructor FUpDown	
	
	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf
	
  	this.Handle  = 0
  	this.ExStyle = 0	
	this.Style 	 =  WS_CHILD Or WS_VISIBLE 
end Constructor

Destructor FUpDown
   this.Handle  = 0
End Destructor

Property FUpDown.Upper(ByVal value As Short)
	If this.Handle Then
		this.b_UP = value
		SendMessage(this.Handle,UDM_SETRANGE,0,MAKELONG(this.b_UP, this.b_LO))
	EndIf
End Property
Property FUpDown.Upper As Short
	Dim As UInteger nRange
	If this.Handle Then
		nRange = SendMessage(this.Handle,UDM_GETRANGE,0,0)
		this.b_UP = LoWord(nRange)
	EndIf
	Return this.b_UP
End Property
Property FUpDown.Lower(ByVal value As Short)
	If this.Handle Then
		this.b_LO = value
		SendMessage(this.Handle,UDM_SETRANGE,0,MAKELONG(this.b_UP, this.b_LO))
	EndIf
End Property
Property FUpDown.Lower As Short
	Dim As UInteger nRange
	If this.Handle Then
		nRange = SendMessage(this.Handle,UDM_GETRANGE,0,0)
		this.b_LO = HiWord(nRange)
	EndIf
	Return this.b_LO
End Property
Property FUpDown.Curpos(ByVal value As Short)
	Dim zTxt As ZString * 16
	If this.Handle Then
		this.b_POS = value
		SendMessage(this.Handle,UDM_SETPOS ,0,MAKELONG(value, 0))
		If this.b_hBuddy Then
			zTxt = Str(value)
			SetWindowText(this.b_hBuddy,@zTxt)
		EndIf
	EndIf
End Property
Property FUpDown.Curpos As Short
	If this.Handle Then
		this.b_POS = SendMessage(this.Handle,UDM_GETPOS,0,0)
	EndIf
	Return this.b_POS
End Property
Property FUpDown.Buddy(ByVal value As HWND)
	Dim zTxt As ZString * 16
	If this.Handle Then
		this.b_hBuddy = value
		SendMessage(this.Handle,UDM_SETBUDDY,Cast(WPARAM, value),0)
		zTxt = Str(this.Curpos)
		SendMessage(this.Buddy,WM_SETTEXT,0,CInt(@zTxt))
	EndIf
End Property
Property FUpDown.Buddy As HWND
	Return this.b_hBuddy
End Property
sub FUpDown.Range(ByVal min As  USHORT ,ByVal max As  USHORT )	
	If this.Handle Then
		this.b_LO = min
		this.b_UP = max
		SendMessage(this.Handle,UDM_SETRANGE,0,MAKELONG(this.b_UP, this.b_LO))
	EndIf
End Sub
Function FUpDown.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
	
	Dim zTxt As ZString * 16
	Dim As RECT rc
	
   Function = 0 
  
   Select case uMsg   	
    	Case WM_ENABLE 
   		this.Enabled = wParam
   		Exit Function
   		
   	Case WM_SIZE
         IF this.Handle THEN
             MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
         END IF
         EXIT Function
         
      Case WM_ERASEBKGND 
         Dim As RECT rc
         GetClientRect(hWnd,@rc)
         FillRect(Cast(HDC,wParam),@rc,GetStockObject(NULL_BRUSH))
         Function = TRUE
         Exit Function
            	
   	Case WM_HSCROLL  		
   		Select Case LoWord(wParam)
   			Case SB_THUMBPOSITION  		
		   		If this.onChange Then onChange(HIWORD(wParam))
		   		If this.Buddy Then
		   			zTxt = Str(HIWORD(wParam))
		   			SendMessage(this.Buddy,WM_SETTEXT,0,CInt(@zTxt))
		   		EndIf
		   		Exit Function
   		End Select
      		
   	Case  WM_VSCROLL	
   		Select Case LoWord(wParam)
   			Case SB_THUMBPOSITION  		
		   		If this.onChange Then onChange(HIWORD(wParam))
		   		If this.Buddy Then
		   			zTxt = Str(HIWORD(wParam))
		   			SendMessage(this.Buddy,WM_SETTEXT,0,CInt(@zTxt))
		   		EndIf
		   		Exit Function
   		End Select
   End Select
  
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
end Function
'
Sub FUpDown.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	
   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
   
    this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , x, y, w , h , _
                          hParent , NULL, hInst , NULL )

   SetWindowLong(this.CtHandle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz

   IF this.CtHandle  THEN
        this.Left    = x
        this.Top     = y
        this.Width   = w
        this.Height  = h
        this.Parent  = hParent
   ELSE
        MessageBox(0,"Fehler - Create UPDOWN","Fehler",MB_ICONERROR)
        EXIT SUB
   END If
   
   szClass =  "msctls_updown32"
         
   this.Handle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , 0, 0, w , h , _
                          this.CtHandle , NULL, hInst , NULL )                                               
  
   If this.Handle = 0  Then
   	MessageBox(0,"Fehler - Create UPDOWN","Fehler",MB_ICONERROR)
   End If
  
End Sub

'---------------------------------------------------------------------------------------------------------
' Trackbar
'--------------------------------------------------------------------------------------------------------- 
Type FTrackbar Extends Control
	
	public:		    
   Declare Property TumpColor(ByVal value As UInteger)
   Declare Property TumpColor As UInteger 
   Declare Property RilColor(ByVal value As UInteger)
   Declare Property RilColor As UInteger 
   Declare Property DefTump(ByVal value As Integer)
   Declare Property DefTump As Integer 
   Declare Property Tick(ByVal value As Integer)
   Declare Property Tick As Integer 
   Declare Property TumpPos(ByVal value As Integer)
   Declare Property TumpPos As Integer 
	Declare Property Border(ByVal value As Integer)
   Declare Property Border As Integer 
   Declare Property Orientation(ByVal value As Integer) ' vordefiniert = Horizontal ;  Orientation = 1 Vertical
   Declare Property Orientation As Integer 
   Declare sub Range(ByVal min As  USHORT ,ByVal max As  USHORT )
   Declare Sub Create(ByVal hParent As HWND,  ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor

   ' Events	
   onChange As SUB( ByVal tbPos As Integer)	
   
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT  
	Private:   
	As Integer  b_Orient		= 0	' horizontal
	As Integer  b_Border		= 0
	As HBRUSH	b_Brush		= 0
	As UInteger b_TumpColor	= &HBBBBBB
	As UInteger b_RilColor	= &HEEEEEE
	As Integer  b_DefTump	= FALSE
	As Integer  b_Tick		= TRUE
End Type

Constructor FTrackbar
	
	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf	
	this.Handle = 0
	this.Style 	= WS_CHILD or WS_VISIBLE or TBS_TOOLTIPS  Or TBS_FIXEDLENGTH OR  TBS_AUTOTICKS 
	'this.Style 	= WS_CHILD or WS_VISIBLE or TBS_TOOLTIPS  Or TBS_ENABLESELRANGE OR  TBS_AUTOTICKS ' breite Rille
End Constructor 

Destructor FTrackbar
	If this.b_Brush Then
		DeleteObject(this.b_Brush)
   EndIf
   this.Handle  = 0
End Destructor

Property FTrackbar.TumpPos(ByVal value As Integer)
	Dim As Integer nMin,nMax
	If this.Handle Then
		nMin = SendMessage(this.Handle, TBM_GETRANGEMIN , 0 , 0)
		nMax = SendMessage(this.Handle, TBM_GETRANGEMAX , 0 , 0)
		If (value <= nMax) And (value >= nMin) Then
			SendMessage(this.Handle, TBM_SETPOS, TRUE , value)
		EndIf
	EndIf
End Property
Property FTrackbar.TumpPos As Integer 
	If this.Handle Then
		Return SendMessage(this.Handle, TBM_GETPOS, 0, 0)
	EndIf
End Property
Property FTrackbar.TumpColor(ByVal value As UInteger)
	If this.Handle Then
		this.b_TumpColor = value
		Repaint
	EndIf
End Property
Property FTrackbar.TumpColor As UInteger 
	Return this.b_TumpColor
End Property
Property FTrackbar.RilColor(ByVal value As UInteger)
	If this.Handle Then
		this.b_RilColor = value
		Repaint
	EndIf
End Property
Property FTrackbar.RilColor As UInteger 
	Return this.b_RilColor
End Property
Property FTrackbar.DefTump(ByVal value As Integer)
	If this.Handle Then
		this.b_DefTump = IIf(value,TRUE,FALSE)
	EndIf
End Property
Property FTrackbar.DefTump As Integer 
	Return this.b_DefTump
End Property
Property FTrackbar.Tick(ByVal value As Integer)
	If this.Handle Then
		If value Then
			this.Style 	= WS_CHILD or WS_VISIBLE or TBS_TOOLTIPS  Or TBS_FIXEDLENGTH OR  TBS_AUTOTICKS Or this.b_Orient  
		Else
			this.Style 	= WS_CHILD or WS_VISIBLE or TBS_TOOLTIPS  Or TBS_FIXEDLENGTH OR TBS_NOTICKS Or this.b_Orient 
		EndIf
		SetWindowLong(this.handle,GWL_STYLE,this.Style)
		Repaint
	EndIf
End Property
Property FTrackbar.Tick As Integer 
	Return this.b_Tick
End Property

Property FTrackbar.Orientation(ByVal value As Integer)
	If this.Handle Then
		Dim  As UInteger styl = GetWindowLong(this.handle,GWL_STYLE)
		If value Then
			this.b_Orient = TBS_VERT 			' <> 0 TBS_VERT 
			styl = styl And (Not TBS_HORZ)
			styl = styl Or TBS_VERT
		Else
			this.b_Orient = TBS_HORZ			' 0 = TBS_HORZ
			styl = styl And (Not TBS_VERT )
			styl = styl Or TBS_HORZ
		EndIf	
		this.Style = styl
		SetWindowLong(this.handle,GWL_STYLE,this.Style)
		Repaint
	EndIf
End Property
Property FTrackbar.Orientation As Integer 
	Return this.b_Orient
End Property
Property FTrackbar.Border(ByVal value As Integer)
	If this.Handle Then
		this.b_Border = value
		Select Case value
			Case 0
				this.Style = WS_CHILD or WS_VISIBLE or TBS_AUTOTICKS Or TBS_FIXEDLENGTH Or this.b_Orient 
				this.ExStyle = 0
			Case 1
				this.Style = WS_CHILD or WS_VISIBLE or TBS_AUTOTICKS Or TBS_FIXEDLENGTH Or WS_BORDER Or this.b_Orient
				this.ExStyle = 0
			Case 2
				this.Style = WS_CHILD or WS_VISIBLE or TBS_AUTOTICKS Or TBS_FIXEDLENGTH Or this.b_Orient
				this.ExStyle = WS_EX_CLIENTEDGE 
		End Select
			SetWindowLong(this.handle,GWL_STYLE,this.Style)
			SetWindowLong(this.handle,GWL_EXSTYLE,this.ExStyle)
			SetWindowPos(this.handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf
End Property
Property FTrackbar.Border As Integer 
	Return this.b_Border
End Property

Function FTrackbar.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT  
	
   Dim As Integer nPos
 	Dim As HBRUSH hBrush
 	
  	Select Case uMsg
  		
  		CASE WM_ENABLE
         this.Enabled = wParam
         EXIT Function

   	Case WM_SIZE
         IF this.Handle THEN
             MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
         END IF
         EXIT Function
      
  		Case WM_NOTIFY
  			Dim As NMCUSTOMDRAW Ptr pNMCD = Cast(Any Ptr, LPARAM)   		
   		If pNMCD->hdr.hwndFrom = this.Handle THEN    
   			If pNMCD->hdr.code = NM_CUSTOMDRAW THEN 
    			Select CASE pNMCD->dwDrawStage
    				Case CDDS_PREPAINT
    					' Wenn hier NULL zurckgegeben wird kommen keine weiteren PREPAINT Messagen
        				Function = CDRF_NOTIFYITEMDRAW 	'CDRF_NOTIFYITEMDRAW OR CDRF_NOTIFYPOSTPAINT		
        				Exit FUNCTION 
    				case CDDS_PREERASE , CDDS_POSTERASE ,CDDS_ITEMPREERASE, CDDS_ITEMPOSTERASE
    					Function = CDRF_DODEFAULT	
        				Exit FUNCTION 
        				
    				case CDDS_ITEMPREPAINT
    					Select Case pNMCD->dwItemSpec
    						Case TBCD_CHANNEL
         					DrawEdge(pNMCD->hdc, @pNMCD->rc, EDGE_SUNKEN , BF_RECT ) ' Rnder der Rille
         					InflateRect( @pNMCD->rc, -1, -1 )  
         					hBrush = CreateSolidBrush(this.b_RilColor) ' color der Rille
         					FillRect(pNMCD->hdc, @pNMCD->rc, hBrush )  ' Rille fllen
         					DeleteObject hBrush
         					Function = CDRF_SKIPDEFAULT    				 'fertig keine weiteren Zeichnungen
    							' wen weiter Zeichnung dann Function = CDRF_DODEFAULT Or CDRF_NOTIFYPOSTPAINT
    							Exit Function
    						case TBCD_TICS	
    							Function =  CDRF_DODEFAULT						 'fertig keine weiteren Zeichnungen
    							Exit Function
    						case TBCD_THUMB
    							If this.b_DefTump Then
    								Function =  CDRF_DODEFAULT					 'fertig keine weiteren Zeichnungen
    								Exit Function
    							Else	
    								hBrush = CreateSolidBrush(b_TumpColor) 
         						FillRect(pNMCD->hdc, @pNMCD->rc, hBrush )  
         						DeleteObject hBrush
         						DrawEdge(pNMCD->hdc, @pNMCD->rc, BDR_RAISEDOUTER , BF_RECT )
         						Function = CDRF_SKIPDEFAULT				'fertig keine weiteren Zeichnungen
    								Exit Function
    							End if	
    					End Select
    			End Select
   			EndIf
   		EndIf	
   		
       
  		Case WM_CTLCOLORSTATIC 
			If this.b_Brush Then
				DeleteObject(this.b_Brush)
			EndIf
  		  	this.b_Brush = CreateSolidBrush(This.Color)
  		  	Function = Cast(LRESULT,this.b_Brush)
  		  	Exit Function
  		  	
  		Case WM_HSCROLL 
  			Select Case LoWord(wParam)  				
  				Case SB_THUMBTRACK
  					If this.onChange Then this.onChange(HIWORD(wParam))	
  				Case SB_BOTTOM, SB_LINEDOWN, SB_LINEUP, SB_TOP
  					nPos = SendMessage(this.Handle, TBM_GETPOS, 0, 0)
  					If this.onChange Then this.onChange(nPos)
  				Case SB_ENDSCROLL
  					nPos = SendMessage(this.Handle, TBM_GETPOS, 0, 0)
  					If this.onChange Then this.onChange(nPos)
  			End Select
  			Function = 0
  			Exit Function
  			
  		Case WM_VSCROLL 
  			Select Case LoWord(wParam) 				
  				Case SB_THUMBTRACK
  					If this.onChange Then this.onChange(HIWORD(wParam))
  				Case SB_BOTTOM, SB_LINEDOWN, SB_LINEUP, SB_TOP
  					nPos = SendMessage(this.Handle, TBM_GETPOS, 0, 0)
  					If this.onChange Then this.onChange(nPos)
  				Case SB_ENDSCROLL
  					nPos = SendMessage(this.Handle, TBM_GETPOS, 0, 0)
  					If this.onChange Then this.onChange(nPos)	
  			End Select
  			Function = 0
  			Exit Function
  	End Select
   
    Function = DefWindowProc(hWnd,uMsg,wParam,lParam)  
End Function

Sub FTrackbar.Create(ByVal hParent As HWND,  ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	
	Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
   
    this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , x, y, w , h , _
                          hParent , NULL, hInst , NULL )

   SetWindowLong(this.CtHandle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz

   IF this.CtHandle  THEN
        this.Left    = x
        this.Top     = y
        this.Width   = w
        this.Height  = h
        this.Parent  = hParent
   ELSE
        MessageBox(0,"Fehler - Create UPDOWN","Fehler",MB_ICONERROR)
        EXIT SUB
   END If
  	
	this.Handle = CreateWindowEx( this.ExStyle , TRACKBAR_CLASS ,"" , this.Style , 0, 0, w, h , this.CtHandle ,NULL, hInst, NULL)
	
   If this.Handle = 0 Then   	
   	MessageBox(0,"Create Trackbar ist fehl geschlagen","Fehler",MB_ICONERROR)
   EndIf
   
End Sub
sub FTrackbar.Range(ByVal min As  USHORT ,ByVal max As  USHORT )
	If this.Handle Then
		SendMessage(this.Handle,TBM_SETRANGE ,TRUE, MAKELONG(min, max))
		RePaint
	EndIf
End Sub
